scala.tools.nsc.Global

# Run

###
Related Doc: package Global

#### class Run extends RunContextApi with RunReporting with RunParsing

A Run is a single execution of the compiler on a set of units.

Source
  Global.scala

Linear Supertypes
Global.RunParsing, Global.RunReporting, Global.RunContextApi, AnyRef, Any
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Run
2. RunParsing
3. RunReporting
4. RunContextApi
5. AnyRef
6. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Run()

### Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from Run to any2stringadd[Run] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (Run, B)

   Implicit information
     This member is added by an implicit conversion from Run to ArrowAssoc[Run] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### def advancePhase(): Unit

   take note that phase is completed (for progress reporting)

7. #### def advanceUnit(): Unit

   take note that a phase on a unit is completed (for progress reporting)

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def canRedefine(sym: Global.Symbol): Boolean

   Is this run allowed to redefine the given symbol? Usually this is true if the run does not already compile `sym`, but for interactive mode we have a more liberal interpretation.

10. #### def cancel(): Unit

11. #### val cleanupPhase: Phase

12. #### def clone(): AnyRef

    Create a copy of the receiver object.

    Create a copy of the receiver object.

    The default implementation of the `clone` method is platform dependent.

    returns

      a copy of the receiver object.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
    Note

      not specified by SLS as a member of AnyRef

13. #### val closelimPhase: Phase

14. #### def compile(filenames: List[String]): Unit

    Compile list of files given by their names

15. #### def compileFiles(files: List[AbstractFile]): Unit

    Compile list of abstract files.

16. #### def compileLate(unit: Global.CompilationUnit): Unit

    Compile abstract file until `globalPhase`, but at least to phase "namer".

17. #### def compileLate(file: AbstractFile): Unit

    Compile abstract file until `globalPhase`, but at least to phase "namer".

18. #### def compileSources(sources: List[SourceFile]): Unit

    Compile list of source files, unless there is a problem already, such as a plugin was passed a bad option.

19. #### def compileUnits(units: List[Global.CompilationUnit], fromPhase: Phase): Unit

20. #### val compiledFiles: HashSet[String]

21. #### def compiles(sym: Global.Symbol): Boolean

    does this run compile given class, module, or case factory?

22. #### var currentUnit: Global.CompilationUnit

    The currently compiled unit; set from GlobalPhase

    The currently compiled unit; set from GlobalPhase

    Definition Classes
      Run → RunContextApi

23. #### val dcePhase: Phase

24. #### val delambdafyPhase: Phase

25. #### def deprecationWarnings: List[(Global.Position, String)]

26. #### def ensuring(cond: (Run) ⇒ Boolean, msg: ⇒ Any): Run

    Implicit information
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

27. #### def ensuring(cond: (Run) ⇒ Boolean): Run

    Implicit information
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

28. #### def ensuring(cond: Boolean, msg: ⇒ Any): Run

    Implicit information
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

29. #### def ensuring(cond: Boolean): Run

    Implicit information
      This member is added by an implicit conversion from Run to Ensuring[Run] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

30. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

31. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

32. #### val erasurePhase: Phase

33. #### val explicitouterPhase: Phase

34. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

35. #### val flattenPhase: Phase

36. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from Run to StringFormat[Run] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

37. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

38. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

39. #### val icodePhase: Phase

40. #### def informUnitStarting(phase: Phase, unit: Global.CompilationUnit): Unit

    For subclasses to override.

    For subclasses to override. Called when `phase` is about to be run on `unit`. Variables are passed explicitly to indicate that `globalPhase` and `currentUnit` have been set.

41. #### val inlineExceptionHandlersPhase: Phase

42. #### val inlinerPhase: Phase

43. #### var isDefined: Boolean

    Have been running into too many init order issues with Run during erroneous conditions.

    Have been running into too many init order issues with Run during erroneous conditions. Moved all these vals up to the top of the file so at least they're not trivially null.

44. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

45. #### val lambdaliftPhase: Phase

46. #### val mixinPhase: Phase

47. #### val namerPhase: Phase

48. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

49. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

50. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

51. #### val parserPhase: Phase

    All phases as of 3/2012 here for handiness; the ones in active use uncommented.

52. #### val parsing: Global.PerRunParsing

    Definition Classes
      RunParsing

53. #### def phaseNamed(name: String): Phase

54. #### val picklerPhase: Phase

55. #### val posterasurePhase: Phase

56. #### def progress(current: Int, total: Int): Unit

    Progress tracking.

    Progress tracking. Measured in "progress units" which are 1 per compilation unit per phase completed.

    current

      number of "progress units" completed

    total

      total number of "progress units" in run

57. #### val refchecksPhase: Phase

58. #### def registerPickle(sym: Global.Symbol): Unit

59. #### val reporting: Global.PerRunReporting

    Definition Classes
      RunReporting

60. #### def runCheckers(): Unit

    Attributes
      protected

61. #### val runDefinitions: reflect.internal.Definitions.definitions.RunDefinitions

    Caching member symbols that are def-s in Definitions because they might change from Run to Run.

62. #### def runIsAt(ph: Phase): Boolean

63. #### def runIsAtOptimiz: Boolean

64. #### def size: Int

65. #### def skipPhase(name: String): Boolean

    Should we skip the given phase?

    Should we skip the given phase?

    Attributes
      protected

66. #### val specializePhase: Phase

67. #### def stopPhase(name: String): Boolean

    Should we stop right before entering the given phase?

    Should we stop right before entering the given phase?

    Attributes
      protected

68. #### val symData: HashMap[Global.Symbol, PickleBuffer]

    A map from compiled top-level symbols to their picklers

69. #### val symSource: HashMap[Global.Symbol, AbstractFile]

    A map from compiled top-level symbols to their source files

70. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

71. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      Run → AnyRef → Any

72. #### object trackerFactory extends SymbolTrackers

73. #### val typerPhase: Phase

74. #### def uncheckedWarnings: List[(Global.Position, String)]

75. #### val uncurryPhase: Phase

76. #### def units: Iterator[Global.CompilationUnit]

    Definition Classes
      Run → RunContextApi

77. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

78. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

79. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

80. #### def →[B](y: B): (Run, B)

    Implicit information
      This member is added by an implicit conversion from Run to ArrowAssoc[Run] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from Global.RunParsing

### Inherited from Global.RunReporting

### Inherited from Global.RunContextApi

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from Run to any2stringadd[Run]

### Inherited by implicit conversion StringFormat from Run to StringFormat[Run]

### Inherited by implicit conversion Ensuring from Run to Ensuring[Run]

### Inherited by implicit conversion ArrowAssoc from Run to ArrowAssoc[Run]

### Ungrouped